#!/usr/bin/tcl
# Please modify the lines below for your database
set dbiconnectstring dbi:mysql:uni 
set connect_user root
set sample_query {select * from Student}

load ./libdbitotcl.so

puts "drivers: [dbi::invoke available_drivers]"

dbi::setnull _NULL_

set conn [dbi::connect $dbiconnectstring $connect_user]
#if you need a password
#set conn [dbi::connect $dbiconnectstring $connect_user password]

puts "connection $conn"

puts "functions on database handle"
puts "tables: [$conn invoke tables]"
puts "errstr: [$conn invoke errstr]"
puts "err: [$conn invoke err]"
puts "state: [$conn invoke state]"
#puts "type_info_all: [$conn invoke type_info_all]"
#puts "type_info: [$conn invoke type_info]"
puts "quoting: [$conn quote {rew`rerw}]"
puts "quoting2: [$conn invoke quote {rew`rerw}]"

#Using Internal DBI::mysql Function
#Remove the line bolow if you use another DBD Device
puts "Mysql DBI internal func: [$conn invoke func _ListTables]"

puts "attributes of on database handle"
puts "name: [$conn attribute Name]"

puts "fetching table_info from database handler"
set ast [$conn table_info]
while {[set row [$ast fetchrow]]!=""} {
    puts $row
}

#puts [$conn do "INSERT INTO Student (Name,Semester) VALUES ('Artur',11)"]

puts "inserted"

set result [$conn prepare $sample_query]
puts $result

$result execute
puts extecute

set rows [$result invoke rows]
puts "rows=$rows"

puts "NUM_OF_FIELDS: [$result attribute NUM_OF_FIELDS]"
puts "NAME: [$result attribute NAME]"
puts "PRECISION: [$result attribute PRECISION]"
puts "SCALE: [$result attribute SCALE]"
puts "NULLABLE: [$result attribute NULLABLE]"
puts "TYPE: [$result attribute TYPE]"

puts "is_key: [$result attribute mysql_is_key]"

for {set x 0} {$x<$rows} {incr x} {
    puts [$result fetchrow]
}
puts "end fetch"
$result finish 
puts "finish"

$conn disconnect
puts "disconnect"
